﻿@using SPAWebApp.Shared
@using SPAWebApp.Shared.Models
@using SPAWebApp.Client.Services.Contracts
@inject IProductCardService ProductCardService
@inject SPAWebApp.Client.Services.Contracts.IFileStorageService FileStorageService
@using System.IO
@using SPAWebApp.Shared.Models.Services.ConstructDocument
@using SPAWebApp.Shared.Models.Services.Product
@using SPAWebApp.Shared.Models.ViewModels.ConstructDocument
@using SPAWebApp.Shared.Models.ViewModels.FileService
@inject IConstructDocumentService ConstructDocumentService
@inject Blazor.FileReader.IFileReaderService FileReaderService


<div class="container-fluid no-margin no-padding d-flex flex-column">
  <div class="row no-margin no-padding content-files">
    <div class="top-menu">
      <button class="btn btn-info" title="Изменить"><i class="fas fa-pen-fancy"></i></button>
      <button class="btn btn-info" title="Экспорт"><i class="fas fa-file-excel"></i></button>
      <button class="btn btn-info" title="Удалить" onclick="@(() => RemoveProduct())"><i class="fas fa-trash-alt"></i></button>
      <button class="btn btn-info" title="Отобразить"> <i class="fas fa-cube"></i> </button>
      <div class="custom-file">
        <input type="file" class="custom-file-input" id="inputGroupFile04" ref="inputTypeFileElement" onchange="@ReadFile" />
        <label class="custom-file-label" for="inputGroupFile04">Choose file</label>
        <button class="btn btn-info" title="Подключить"><i class="fas fa-paperclip" onclick="@(() => ChangeAddState())"></i></button>
      </div>
    </div>
  </div>
  <div class="row no-margin no-padding">
    @if (Product == null)
    {
      <p>Please Wait...</p>
    }
    else
    {
      <table class="p-i-table">

        <tr>
          <td class="p-i-td">Наименование</td>
          <td class="p-i-td">@Product.Name</td>
        </tr>
        <tr>
          <td class="p-i-td">Обозначение</td>
          <td class="p-i-td">@Product.Designation</td>
        </tr>
        <tr>
          <td class="p-i-td">Версия</td>
          <td class="p-i-td">@Product.Version</td>
        </tr>
        <tr>
          <td class="p-i-td">Состояние</td>
          <td class="p-i-td">@Product.State</td>
        </tr>
        <tr>
          <td class="p-i-td">Вес</td>
          <td class="p-i-td">@Product.Weight</td>
        </tr>
        <tr>
          <td class="p-i-td">Файлы</td>
          <td class="p-i-td">@Output</td>
        </tr>
      </table>
    }

  </div>

  @if (RelatedDocuments != null)
  {
    <table class="k-table">
      <thead class="k-thead">
        <tr class="table-headers k-tr">
          <th class="k-th">Обозначение</th>
          <th class="k-th">Версия</th>
          <th class="k-th">Состояние</th>
          <th class="k-th">Наименование</th>
          <th class="k-th">Файлы</th>
        </tr>
      </thead>
      <tbody>
        @foreach (var document in RelatedDocuments)
        {
          <tr class="hand-hover k-tr">

            <td class="k-td">@document.Designation</td>
            <td class="k-td">@document.Revision</td>
            <td class="k-td">@document.State</td>
            <td class="k-td">@document.Name</td>
            <td class="k-td"></td>
          </tr>
        }
      </tbody>
    </table>
  }
  else
  {
    if (RelDocument == null)
    {
      <table class="k-table">
        <thead class="k-thead">
          <tr class="table-headers k-tr">
            <th class="k-th">Обозначение</th>
            <th class="k-th">Версия</th>
            <th class="k-th">Состояние</th>
            <th class="k-th">Наименование</th>
            <th class="k-th">Файлы</th>
          </tr>
        </thead>
        <tbody>
          @if (Documents != null)
          {
            @foreach (var doc in Documents)
            {
              <tr class="hand-hover k-tr" onclick="@(() => SelectDocumentForRel(doc))">

                <td class="k-td">@doc.Designation</td>
                <td class="k-td">@doc.Revision</td>
                <td class="k-td">@doc.State</td>
                <td class="k-td">@doc.Name</td>
                <td class="k-td"></td>
              </tr>
            }
          }

        </tbody>
      </table>
    }
    else
    {
      <EditForm Model="@CreateNewRelModel" OnValidSubmit="@(async () => await CreateNewRelAsync())">
        <div class="form-group row">
          <label for="InputText" class="col-sm-2 col-form-label">Product Id</label>
          <div class="col-sm-10">
            <input type="text" class="form-control" placeholder="@Product.Id" value="@Product.Id" bind="@CreateNewRelModel.ProductId" disabled="disabled" />
          </div>
        </div>
        <div class="form-group row">
          <label for="InputText" class="col-sm-2 col-form-label">Document Id</label>
          <div class="col-sm-10">
            <input type="text" class="form-control" placeholder="@RelDocument" value="@RelDocument" bind="@CreateNewRelModel.DocumentId" disabled="disabled" />
          </div>
        </div>
        <div class="form-group row">
          <label for="InputText" class="col-sm-2 col-form-label">Relationship Type</label>
          <div class="col-sm-10">
            <input type="text" class="form-control" placeholder="Type" bind="@CreateNewRelModel.Type" />
          </div>
        </div>
        <button class="btn btn-info" title="OK" type="submit"><i class="fas fa-check-square"></i></button>
      </EditForm>
    }
  }
  <!-- 3DViewer -->
  @*<div id="VRMLViewer" class="row justify-content-md-center w-100 flex-fill d-flex">
      <div class="col-11">
        <SPAWebApp.Client.Pages.VRMLViewer.Viewer />
      </div>
    </div>*@
  <!-- End 3DViewer -->
</div>

@functions {
  public int PagesCount { get; set; } = 0;

  public int CurrentPage { get; set; } = 0;
  private async void ChangeAddState()
  {
    AddState = true;
    var result = await ConstructDocumentService.GetDocumentsOfFirstPageAsync();
    Documents = result.Documents;
    CurrentPage = 0;
    PagesCount = result.Pages;

    StateHasChanged();
  }

  protected bool AddState = false;

  private async Task CreateNewRelAsync()
  {
    AddState = false;
    StateHasChanged();
  }
  protected CreateNewRelModel CreateNewRelModel { get; set; } = new CreateNewRelModel();
  private void SelectDocumentForRel(Document doc)
  {
    RelDocument = doc.Id;
  }

  private List<Document> Documents = new List<Document>();
  private string RelDocument;
  private string RelType;

  [Parameter]
  protected Product Product { get; set; }
  ElementRef fileUpload;
  string dataSize = String.Empty;
  async Task UploadFile()
  {
    var data = await FileReaderService.CreateReference(fileUpload).EnumerateFilesAsync();
    using (MemoryStream memoryStream = await data.First().CreateMemoryStreamAsync())
    {

      dataSize = "size = " + Convert.ToBase64String(memoryStream.ToArray());
      byte[] Filebyte = memoryStream.ToArray();
      System.IO.File.WriteAllBytes("C:/Users/Elor/Downloads/Обои/file.txt", Filebyte);
      ;
    }
  }

  private List<Document> RelatedDocuments;

  protected override async Task OnInitAsync()
  {
    RelatedDocuments = await ProductCardService.GetRelatedDocuments(Product.Id);
  }

  ElementRef inputTypeFileElement;
  string Output = String.Empty;
  string fileFullName = string.Empty;
  public async Task ReadFile()
  {

    var nl = Environment.NewLine;
    var fileByte = await FileReaderService.CreateReference(inputTypeFileElement).EnumerateFilesAsync();
    MemoryStream memoryStream = await fileByte.First().CreateMemoryStreamAsync();
    foreach (var file in await FileReaderService.CreateReference(inputTypeFileElement).EnumerateFilesAsync())
    {
      var fileInfo = await file.ReadFileInfoAsync();
      fileFullName = fileInfo.Name;

    }
    string[] fileNameWithType = fileFullName.Split('.');
    Console.WriteLine(fileNameWithType[0] + "  " + fileNameWithType[1] + "  " + memoryStream.Length.ToString());
    UploadFileVM UploadFileViewModel = new UploadFileVM(memoryStream.ToArray(), fileNameWithType[0], fileNameWithType[1], "");
    await FileStorageService.UploadFileAsync(UploadFileViewModel);
    this.StateHasChanged();
  }

  public async Task RemoveProduct()
  {
    await ProductCardService.RemoveProductAsync(Product.Id);
  }

}
